#include "I2C_Driver.h"
#include "demo.h"

/********************************************************/
/* Private define ------------------------------------------------------------*/
#define I2c_BufferSize1             (countof(I2c_Tx1_Buffer))
 
/* ----------------------- Static variables ---------------------------------*/
//Ҫд뵽24LC64ַ
u8 I2c_Tx1_Buffer[] = {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0B,0x0C,0x0D,0x0E,0x0F};
u8 I2c_Rx1_Buffer[I2c_BufferSize1];
u8 I2c_Data_Temp;

/********************************************************/ 

void I2C_GPIO_Config(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure; 

  /* Configure I2C1 pins: SCL and SDA */
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;  	//©
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_7;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
}


void I2C_delay(void)
{	
   u8 i= 5; //Żٶ	͵5д
   while(i) 
   { 
     i--; 
   } 
}

/*********************************************************************
    :	IICʼź
ֵ 			
˵		
*********************************************************************/
u8 I2C_Start(void)
{
	SDA_H;
	SCL_H;
	I2C_delay();
	if(!SDA_read)return 0;	//SDAΪ͵ƽæ,˳
	SDA_L;
	I2C_delay();
	if(SDA_read) return 0;	//SDAΪߵƽ߳,˳
	SDA_L;
	I2C_delay();
	return 1;
}

/*********************************************************************
    :	IICֹͣź
ֵ 			
˵		
*********************************************************************/
void I2C_Stop(void)
{
	SCL_L;
	I2C_delay();
	SDA_L;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SDA_H;
	I2C_delay();
}

/*********************************************************************
    :	ACKӦ
ֵ 			
˵		
*********************************************************************/
void I2C_Ack(void)
{	
	SCL_L;
	I2C_delay();
	SDA_L;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SCL_L;
	I2C_delay();
}

/*********************************************************************
    :	ACKӦ
ֵ 			
˵		
*********************************************************************/
void I2C_NoAck(void)
{	
	SCL_L;
	I2C_delay();
	SDA_H;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SCL_L;
	I2C_delay();
}

/*********************************************************************
    :	ȴӦźŵ
ֵ 		1ACK
			0ACK 	
˵		
*********************************************************************/
u8 I2C_WaitAck(void)
{
	SCL_L;
	I2C_delay();
	SDA_H;			
	I2C_delay();
	SCL_H;
	I2C_delay();
	if(SDA_read)
	{
      SCL_L;
	  I2C_delay();
      return 0;
	}
	SCL_L;
	I2C_delay();
	return 1;
}

/*********************************************************************
    :	I2Cһλݵ
 		͵ 	
˵	ݴӸλλ	
*********************************************************************/
void I2C_SendByte(u8 SendByte)
{
    u8 i=8;
    while(i--)
    {
        SCL_L;
        I2C_delay();
      if(SendByte&0x80)
        SDA_H;  
      else 
        SDA_L;   
        SendByte<<=1;
        I2C_delay();
		SCL_H;
        I2C_delay();
    }
    SCL_L;
}

/*********************************************************************
    :	I2Cһλݵ
ֵ 		յ 	
˵	ݴӸλλ	
*********************************************************************/
u8 I2C_ReceiveByte(void)
{ 
    u8 i=8;
    u8 ReceiveByte=0;

    SDA_H;				
    while(i--)
    {
      ReceiveByte<<=1;      
      SCL_L;
      I2C_delay();
	  SCL_H;
      I2C_delay();	
      if(SDA_read)
      {
        ReceiveByte|=0x01;
      }
    }
    SCL_L;
    return ReceiveByte;
}

/********************************************************************* 
* Apply Programe *
*********************************************************************/

/*********************************************************************
    :	AT24CXXַָһ
	ReadAddr:ʼĵַ  	
˵		
*********************************************************************/
u8 I2C_ReadOneByte(u16 ReadAddress)
{				  
	u8 temp=0;
			  	    																 
	if(!I2C_Start())return 0;

	if(EE_TYPE>AT24C16)
	{
		I2C_SendByte(0XA0);	   //д
		I2C_WaitAck();
		I2C_SendByte(ReadAddress>>8);//͸ߵַ
		I2C_WaitAck();		 
	}
	else
	{
		I2C_SendByte(0XA0+((ReadAddress/256)<<1));   //ַ0XA0,д 	
		if(!I2C_WaitAck()) {I2C_Stop(); return 0;}	
	} 

	I2C_SendByte((u8)(ReadAddress % 256));   //õʼַ      
    I2C_WaitAck();
    I2C_Start();
    I2C_SendByte(0xA1);
    I2C_WaitAck();

    temp=I2C_ReceiveByte();
    I2C_Stop();
    return temp;		   
}

/*********************************************************************
    :	AT24CXXַָдһ
	WriteAddr  :дݵĿĵַ  
			DataToWrite:Ҫд	
˵		
*********************************************************************/
u8 I2C_WriteOneByte(u16 WriteAddress, u8 DataToWrite)
{		
    if(!I2C_Start())
		return 0;

	if(EE_TYPE>AT24C16)
	{
		I2C_SendByte(0XA0);	    //д
		I2C_WaitAck();
		I2C_SendByte(WriteAddress>>8);//͸ߵַ
		I2C_WaitAck();	 
	}
	else
	{
		I2C_SendByte(0XA0+((WriteAddress/256)<<1));   //ַ0XA0,д 
		if(!I2C_WaitAck()) {I2C_Stop(); return 0;}
	}
    
	I2C_SendByte((u8)(WriteAddress % 256));   //õʼַ   
	 
    I2C_WaitAck();	
    I2C_SendByte(DataToWrite);
    I2C_WaitAck();   
    I2C_Stop(); 
	//ע⣺ΪҪȴEEPROMд꣬Բòѯʱʽ(5ms)
    Delay(5);
    return 1;
}

/*********************************************************************
    :	24CXXǷǷ
	
  ֵ:	1:ʧ
			0:ɹ
˵	24XXһַ(255)洢־.
			24Cϵ,ַҪ޸
*********************************************************************/
u8 I2C_Check(void)
{
	u8 temp;
	temp=I2C_ReadOneByte(255);//ÿοдAT24CXX			   
	if(temp==0X55)return 0;		   
	else//ųһγʼ
	{
		I2C_WriteOneByte(255,0X55);
	    temp=I2C_ReadOneByte(255);	  
		if(temp==0X55)return 0;
	}
	return 1;											  
}

/*********************************************************************
    :	д1
	WriteAddress :ʼдĵַ 24c02Ϊ0~255
			pBuffer   :д׵ַ
			NumToWrite:Ҫдݵĸ
  ֵ:	0		  :дʧ
			1		  :дɹ
˵	עⲻܿҳд	
*********************************************************************/
u8 I2C_BufferWrite(u16 WriteAddress, u8* pBuffer, u8 NumToWrite)
{
    if(!I2C_Start())
		return 0;

	if(EE_TYPE>AT24C16)
	{
		I2C_SendByte(0XA0);	    //д
		I2C_WaitAck();
		I2C_SendByte(WriteAddress>>8);//͸ߵַ
		I2C_WaitAck();	 
	}
	else
	{
		I2C_SendByte(0XA0+((WriteAddress/256)<<1));   //ַ0XA0,д 
		if(!I2C_WaitAck()) {I2C_Stop(); return 0;}
	}
    
	I2C_SendByte((u8)(WriteAddress % 256));   //õʼַ   
    I2C_WaitAck();	
	  
	while(NumToWrite--)
	{
		I2C_SendByte(* pBuffer);
		I2C_WaitAck();
		pBuffer++;
	}

	I2C_Stop(); 
	//ע⣺ΪҪȴEEPROMд꣬Բòѯʱʽ(5ms)
    Delay(5);
    return 1;
}

/*********************************************************************
    :	ҳд1
	WriteAddress 	:дַ 24c02Ϊ0~255
			pBuffer   		:дַ
			NumToWrite		:Ҫдݵĸ
  ֵ:	
˵	עⲻܿҳд	
*********************************************************************/
void I2C_PageWrite(u16 WriteAddress, u8* pBuffer, u16 NumToWrite)
{
    u8 NumOfPage = 0, NumOfSingle = 0, Addr = 0, count = 0;
    Addr  = WriteAddress % I2C_PageSize;		//дַǿʼҳĵڼλ
    count = I2C_PageSize - Addr;				//ڿʼҳҪдĸ
    NumOfPage   =  NumToWrite / I2C_PageSize;	//Ҫдҳ
    NumOfSingle =  NumToWrite % I2C_PageSize; 	//һҳĸ

    if(Addr == 0)         //дַҳĿʼ 
    {
		if(NumOfPage == 0)  //Сһҳ 
		{
			I2C_BufferWrite(WriteAddress, pBuffer, NumOfSingle);	//дһҳ
		}
      	else		            //ݴڵһҳ  
      	{
        	while(NumOfPage)	//Ҫдҳ
        	{
		  		I2C_BufferWrite(WriteAddress, pBuffer, I2C_PageSize);	//дһҳ
          		WriteAddress +=  I2C_PageSize;
          		pBuffer      +=  I2C_PageSize;
				NumOfPage--;
				Delay(5);
         	}
        	if(NumOfSingle!=0)//ʣСһҳ
        	{
				I2C_BufferWrite(WriteAddress, pBuffer, NumOfSingle);	//дһҳ
				Delay(5);
        	}
       	}
    }

    else                  //дַҳĿʼ 
    {
      	if(NumOfPage== 0)   //Сһҳ 
      	{
			I2C_BufferWrite(WriteAddress, pBuffer, NumOfSingle);	//дһҳ
      	}
      	else                //ݴڵһҳ
      	{
        	NumToWrite    -= count;
        	NumOfPage     = NumToWrite / I2C_PageSize;  //¼Ҫдҳ
        	NumOfSingle   = NumToWrite % I2C_PageSize;  //¼㲻һҳĸ	
      
        	if(count != 0)
        	{       
				I2C_BufferWrite(WriteAddress, pBuffer, count);	//ʼĿռдһҳ
          		WriteAddress += count;
          		pBuffer      += count;
         	} 
      
        	while(NumOfPage--)  //Ҫдҳ
        	{
				I2C_BufferWrite(WriteAddress, pBuffer, I2C_PageSize);	//дһҳ
          		WriteAddress +=  I2C_PageSize;
          		pBuffer      +=  I2C_PageSize; 
        	}
        	if(NumOfSingle != 0)//ʣСһҳ
        	{
				I2C_BufferWrite(WriteAddress, pBuffer, NumOfSingle);	//дһҳ
        	}
      	}
    } 
}

/*********************************************************************
    :	1 
	ReadAddress 	:ַ
			pBuffer   		:Ŷ
			NumToRead		: 
  ֵ:	0				ʧ
			1				ɹ
˵	
*********************************************************************/
u8 I2C_ReadByte(u16 ReadAddress, u8* pBuffer, u16 NumToRead)
{		
    if(!I2C_Start())return 0;

	if(EE_TYPE>AT24C16)
	{
		I2C_SendByte(0XA0);	   //д
		I2C_WaitAck();
		I2C_SendByte(ReadAddress>>8);//͸ߵַ
		I2C_WaitAck();		 
	}
	else
	{
		I2C_SendByte(0XA0+((ReadAddress/256)<<1));   //ַ0XA0,д 	
		if(!I2C_WaitAck()) {I2C_Stop(); return 0;}	
	} 

	I2C_SendByte((u8)(ReadAddress % 256));   //õʼַ      
    I2C_WaitAck();

    I2C_Start();
    I2C_SendByte(0xA1);
    I2C_WaitAck();

    while(NumToRead)
    {
      *pBuffer = I2C_ReceiveByte();
      if(NumToRead == 1)I2C_NoAck();
      else I2C_Ack(); 
      pBuffer++;
      NumToRead--;
    }
    I2C_Stop();
    return 1;
}

/*********************************************************************/
//
void I2C_Test(void)
{
	u8 i, I2cReceiveData;
	u8 I2c_Buf[250];

//	while(1)
//	{
//		I2C_WriteOneByte(0x0200, 0x55); 							//дֽ	
//	}
	
//	I2C_WriteOneByte(0x1FFF, 0x55); 							//дֽ
//	  
//	//Delay(4);
//	I2cReceiveData = I2C_ReadOneByte(0x1FFF);					//ֽ
//	I2c_Data_Temp = I2cReceiveData;

	//仺
	for(i=0;i<250;i++)
		I2c_Buf[i]=i;
	
//	//д
//	I2C_Write(EEPROM_WriteAddress1, I2c_Buf, 250);	//дֽ

	I2C_PageWrite(EEPROM_WriteAddress1, I2c_Buf, 0xFA);
	//I2C_BufferWrite(EEPROM_WriteAddress1, I2c_Tx1_Buffer, I2c_BufferSize1);
	
	//建
	for(i=0;i<250;i++)
		I2c_Buf[i]=0;
	I2C_delay();
//		
//	//
//	I2C_Read(EEPROM_ReadAddress1, I2c_Buf, 250);		//ֽ
	I2C_ReadByte(EEPROM_ReadAddress1, I2c_Buf, 0xFA);

}
